﻿IF Exists (Select 1 From Sys.objects Where Name = 'rpt_Get_EventRelated_Hosts' AND Type = 'P')
	DROP PROCEDURE [dbo].[rpt_Get_EventRelated_Hosts]
GO

Create Proc rpt_Get_EventRelated_Hosts
(@i_sSearch_RSAM_ID varchar(100), 
@i_sUserID nvarchar(200) )
AS

--Declare @i_sSearch_RSAM_ID varchar(100) = 'RSAMA6-00003645-321F2C1C0D7C4ED1945457D94FBE3DDF', 
--@i_sUserID nvarchar(200)='r_admin'

	CREATE TABLE #RelatedHosts(
	ID int Identity,
	Hosts Nvarchar(500),
	DOE DateTime
	)
	Declare @i_iSearch_ID Int
	Declare @Text Nvarchar(max) = '', @RecCount Int = 1, @TotalCount Int, @iSearch_ID Int
	Declare @DOE Datetime
	Declare @ATT_TYPE_ID_DateCreated Int, @ATT_TYPE_ID_RelatedHost Int

	SELECT @ATT_TYPE_ID_DateCreated = ATT_TYPE_ID FROM ATTRIBUTETYPE WHERE ATTTYPE_RSAM_ID = 'RSAMR9-00002159-07DF1EEED1CE484A9324322878900405' --Date Created
	SELECT @ATT_TYPE_ID_RelatedHost = ATT_TYPE_ID FROM ATTRIBUTETYPE WHERE ATTTYPE_RSAM_ID = 'RSAMR9-00002157-AF04A07AAFEE46ECA743ED22AF7149C7' --Related Hosts

	Select @i_iSearch_ID = Search_ID From SEARCH Where SEARCH_RSAM_ID = @i_sSearch_RSAM_ID
	CREATE TABLE #TEMP_SEARCH_RESULTS(ID int Identity,ITEM_ID int,Hosts Nvarchar(500) Null,	DOE DateTime Null,HostCount Int Null) -- could be Object ID or Finding ID

	INSERT INTO #TEMP_SEARCH_RESULTS(ITEM_ID)
	EXEC RS_SavedSearch @i_iSearchID = @i_iSearch_ID, @i_sUserID = @i_sUserID, @i_bIgnorePermissions = 1,@i_iGetDataOnlyForFirstColumn = 1,@i_sFieldsToDisplay = ''
	Set @TotalCount = @@ROWCOUNT
	
	Update #TEMP_SEARCH_RESULTS SET Hosts = ATTRIBUTE_DATA
	From FI_FINDING_ATTRIBUTE
	JOIN #TEMP_SEARCH_RESULTS ON FINDING_ID_R = ITEM_ID And ATTTYPE_ID_R = @ATT_TYPE_ID_RelatedHost

	Update #TEMP_SEARCH_RESULTS SET DOE = ATTRIBUTE_DATE
	From FI_FINDING_ATTRIBUTE
	JOIN #TEMP_SEARCH_RESULTS ON FINDING_ID_R = ITEM_ID And ATTTYPE_ID_R = @ATT_TYPE_ID_DateCreated
	
	While @RecCount <= @TotalCount
	BEGIN
		Select @Text = Hosts, @DOE = DOE From #TEMP_SEARCH_RESULTS Where ID = @RecCount And ISNULL(Hosts,'') <> ''
		IF Len(@Text) >1
			Insert Into #RelatedHosts
			Select VALUE,@DOE From dbo.fn_SplitString(@Text,Char(10))
		Set @RecCount = @RecCount + 1
		Set @Text = ''
	END
	Select *, RANK() Over (partition by Hosts order by ID) HostCount  From #RelatedHosts order by hosts, HostCount

	DROP TABLE #TEMP_SEARCH_RESULTS
	Drop table #RelatedHosts



GO 
GRANT EXEC ON rpt_Get_EventRelated_Hosts TO RSAM_CLIENT
IF Exists (Select 1 From Sys.objects Where Name = 'rpt_Get_IncidentRelated_Hosts' AND Type = 'P')
	DROP PROCEDURE [dbo].[rpt_Get_IncidentRelated_Hosts]
GO

Create Proc rpt_Get_IncidentRelated_Hosts 
(@i_sSearch_RSAM_ID varchar(100), 
@i_sUserID nvarchar(200) )
AS

--Declare @i_sSearch_RSAM_ID varchar(100) = 'RSAMA6-00003647-5C18271D57B84F899AF273E5E11C255E', 
--@i_sUserID nvarchar(200)='r_admin'

	CREATE TABLE #RelatedHosts(
	ID int Identity,
	Hosts Nvarchar(500),
	DOE DateTime
	)
	Declare @i_iSearch_ID Int
	Declare @Text Nvarchar(max) = '', @RecCount Int = 1, @TotalCount Int, @iSearch_ID Int
	Declare @DOE Datetime
	Declare @ATT_TYPE_ID_DateCreated Int, @ATT_TYPE_ID_RelatedHost Int

	SELECT @ATT_TYPE_ID_DateCreated = ATT_TYPE_ID FROM ATTRIBUTETYPE WHERE ATTTYPE_RSAM_ID = 'RSAMR9-00002159-07DF1EEED1CE484A9324322878900405' --Date Created
	SELECT @ATT_TYPE_ID_RelatedHost = ATT_TYPE_ID FROM ATTRIBUTETYPE WHERE ATTTYPE_RSAM_ID = 'RSAMR9-00002157-AF04A07AAFEE46ECA743ED22AF7149C7' --Related Hosts

	Select @i_iSearch_ID = Search_ID From SEARCH Where SEARCH_RSAM_ID = @i_sSearch_RSAM_ID
	CREATE TABLE #TEMP_SEARCH_RESULTS(ID int Identity,ITEM_ID int,Hosts Nvarchar(500) Null,	DOE DateTime Null,HostCount Int Null) -- could be Object ID or Finding ID

	INSERT INTO #TEMP_SEARCH_RESULTS(ITEM_ID)
	EXEC RS_SavedSearch @i_iSearchID = @i_iSearch_ID, @i_sUserID = @i_sUserID, @i_bIgnorePermissions = 1,@i_iGetDataOnlyForFirstColumn = 1,@i_sFieldsToDisplay = ''
	Set @TotalCount = @@ROWCOUNT
	
	Update #TEMP_SEARCH_RESULTS SET Hosts = ATTRIBUTE_DATA
	From FI_FINDING_ATTRIBUTE
	JOIN #TEMP_SEARCH_RESULTS ON FINDING_ID_R = ITEM_ID And ATTTYPE_ID_R = @ATT_TYPE_ID_RelatedHost

	Update #TEMP_SEARCH_RESULTS SET DOE = ATTRIBUTE_DATE
	From FI_FINDING_ATTRIBUTE
	JOIN #TEMP_SEARCH_RESULTS ON FINDING_ID_R = ITEM_ID And ATTTYPE_ID_R = @ATT_TYPE_ID_DateCreated
	
	While @RecCount <= @TotalCount
	BEGIN
		Select @Text = Hosts, @DOE = DOE From #TEMP_SEARCH_RESULTS Where ID = @RecCount And ISNULL(Hosts,'') <> ''
		IF Len(@Text) >1
			Insert Into #RelatedHosts
			Select VALUE,@DOE From dbo.fn_SplitString(@Text,Char(10))
		Set @RecCount = @RecCount + 1
		Set @Text = ''
	END
	Select *, RANK() Over (partition by Hosts order by ID) HostCount  From #RelatedHosts order by hosts, HostCount

	DROP TABLE #TEMP_SEARCH_RESULTS
	Drop table #RelatedHosts


GO 
GRANT EXEC ON rpt_Get_IncidentRelated_Hosts TO RSAM_CLIENT
